#include <iostream>
#include <vector>
#include <string>
using namespace std;

void printer(string message,vector<int> data) {
    cout << message << endl;
    for(auto it = data.begin();it!=data.end();++it) cout<<*it;
    cout<<endl;
}

vector<int> vectorize(int arr[]) {
    vector<int> data;
    for(int i=0;i<32;i++) data.push_back(arr[i]);
    return data;
}

vector<int> calcBit(int bits[],int n) {
    if(n==32) return vectorize(bits);
        if(bits[n] == 0 || bits[n] == 2) {
            bits[n] = 1;
            //printer("calcBit first case result", vectorize(bits));
            return vectorize(bits);
        } else {
            bits[n] = 0;
            //printer("calcBit second case result", vectorize(bits));
            return calcBit(bits,n+1);
        }
}

vector<int> bit(int num) {
    int bits[32];
    for(int i=0;i<32;i++) bits[i] = 2;
    //printer("bit beginning", vectorize(bits));
    for(int i=0;i<num;i++) {
        vector<int> bitss = calcBit(bits,0);
        int j=0;
        for(auto it = bitss.begin();it!=bitss.end();++it) {
            bits[j] = *it;
            j++;
        }
    }
    //printer("bit result", vectorize(bits));
    return vectorize(bits);
}

int main() {
    int l,r,k;
    cin >> l >> r >> k;
    int nums = 0;
    for(int i=l;i<=r;i++) {
        vector<int> bits = bit(i);
        int zeroes=0;
        for(auto it = bits.begin();it!=bits.end();++it) if(*it==0) zeroes++;
        if(zeroes == k) {
            nums++;
            zeroes=0;
        }
    }
    cout<<nums;
}
