#include<iostream>
#include<algorithm>
#include<vector>
using namespace std;

int n, m;
int a[1005][1005], ans = 0;
pair<int, int> tl[2005], br[2005];
bool visited[1005][1005], seen[2005];
vector<int> v;

void dfs(int x, int y, int z) {
    if(tl[z].first == 0) tl[z].first = x;
    if(tl[z].second == 0) tl[z].second = y;
    tl[z].first = min(tl[z].first, x);
    tl[z].second = min(tl[z].second, y);
    br[z].first = max(br[z].first, x);
    br[z].second = max(br[z].second, y);

    visited[x][y] = true;
    if(x - 1 >= 1 && !visited[x-1][y] && a[x-1][y] == z) dfs(x-1, y, z);
    if(x + 1 <= n && !visited[x+1][y] && a[x+1][y] == z) dfs(x+1, y, z);
    if(y - 1 >= 1 && !visited[x][y-1] && a[x][y-1] == z) dfs(x, y-1, z);
    if(y + 1 <= n && !visited[x][y+1] && a[x][y+1] == z) dfs(x, y+1, z);
}

void findInfo(int k) {
    for(int i = 1; i <= n; i++) {
        for(int j = 1; j <= m; j++) {
            if(a[i][j] == k) {
                seen[k] = true;
                ans++;
                dfs(i, j, k);
                return;
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin>>n>>m;

    int maxx = 0;
    for(int i = 1; i <= n; i++) {
        for(int j = 1; j <= m; j++) {
            cin>>a[i][j];
            maxx = max(maxx, a[i][j]);
        }
    }

    for(int i = 1; i <= maxx; i++) {
        findInfo(i);
        if(seen[i]) v.push_back(i);
    }

    cout<<ans<<endl;
    for(int i = 0; i < v.size(); i++) {
        cout<<v[i]<<" "<<tl[v[i]].first<<" "<<tl[v[i]].second<<" "<<br[v[i]].first<<" "<<br[v[i]].second<<endl;
    }

    return 0;
}
