#include<iostream>
#include<algorithm>
using namespace std;

string bin(long long n) {
    string s;
    while(n > 0) {
        s += '0' + (n % 2);
        n /= 2;
    }
    //reverse(s.begin(), s.end());
    return s;
}

void findNext(string& s) {
    long long i, j = 0;
    for(i = 0; i < s.size(); i++) {
        if(s[i] == '1') s[i] = '0';
        else {
            s[i] = '1';
            break;
        }
    }
    if(i == s.size()) s += '1';
}

bool isAns(string s, long long k) {
    long long cur = 0;
    for(auto c : s) {
        if(c == '0') {
            cur++;
            if(cur > k) return false;
        }
    }
    if(cur == k) return true;
    return false;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    long long l, r, k;
    cin>>l>>r>>k;

    long long ans = 0;
    string s = bin(l);
    for(long long i = l; i <= r; i++) {
        if(isAns(s, k)) ans++;
        findNext(s);
    }
    cout<<ans<<endl;

    return 0;
}
