#include<bits/stdc++.h>
using namespace std;
int table[1024][1024];
bool counted[2010];
unordered_set<int> uniq;
unordered_set<int> pokrivashti;
pair<int,int> bottomLeft[2010];
pair<int,int>bottomRight[2010];
pair<int,int> topLeft[2010];
pair<int,int> topRight[2010];
pair<int,int> topLeftPoints[2010];
pair<int,int> bottomRightPoints[2010];
vector<int> edges[2010];
bool visited[2010];
int namereni=0;
vector<int> redica;
void dfs(int s) {
    visited[s]=true;
    namereni++;
    redica.push_back(s);
    for(auto sused: edges[s]) {
        if(visited[sused]) continue;
        dfs(sused);
    }
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n,m;
    cin>>n>>m;
    for(int i=1;i<=n;i++) {
        for(int j=1;j<=m;j++) {
            cin>>table[i][j];
            uniq.insert(table[i][j]);
        }
    }
    for(auto i: uniq) {
        topLeft[i].first=-1;
        topLeft[i].second=-1;
        topRight[i].first=-1;
        topRight[i].second=-1;
        bottomLeft[i].first=-1;
        bottomLeft[i].second=-1;
        bottomRight[i].first=-1;
        bottomRight[i].second=-1;
    }
    for(int i=1;i<=n;i++) {
        for(int j=1;j<=m;j++) {
            int seg=table[i][j];
            if(counted[seg]) continue;
            counted[seg]=true;
            for(int y=i;y<=n;y++) {
                for(int x=j;x>=1;x--) {
                    if(table[y][x]==seg) {
                        if(bottomLeft[seg].first==-1 || bottomLeft[seg].second==-1 || x<bottomLeft[seg].second|| y<bottomLeft[seg].first) {
                            bottomLeft[seg].first=y;
                            bottomLeft[seg].second=x;
                        }
                    }
                }
                for(int x=j;x<=m;x++) {
                    if(table[y][x]==seg) {
                        if(bottomRight[seg].first==-1 || bottomRight[seg].second==-1 || x>bottomRight[seg].second || y>bottomRight[seg].first) {
                            bottomRight[seg].first=y;
                            bottomRight[seg].second=x;
                        }
                    }
                }
            }

            for(int y=i;y>=1;y--) {
                for(int x=j;x>=1;x--) {
                    if(table[y][x]==seg) {
                        if(topLeft[seg].first==-1 || topLeft[seg].second==-1 || x<topLeft[seg].second|| y<topLeft[seg].first) {
                            topLeft[seg].first=y;
                            topLeft[seg].second=x;
                        }
                    }
                }
                for(int x=j;x<=m;x++) {
                    if(table[y][x]==seg) {
                        if(topRight[seg].first==-1 || topRight[seg].second==-1 || x>topRight[seg].second || y>topRight[seg].first) {
                            topRight[seg].first=y;
                            topRight[seg].second=x;
                        }
                    }
                }
            }
        }
    }
    uniq.erase(0);
    for(auto i: uniq) {
        topLeftPoints[i]={min(topLeft[i].first,topRight[i].first),min(topLeft[i].second,bottomLeft[i].second)};
        bottomRightPoints[i]={max(bottomLeft[i].first,bottomRight[i].first),max(topRight[i].second,bottomRight[i].second)};
        /*
        cout<<i<<endl;
        cout<<topLeftPoints[i].first<<" "<<topLeftPoints[i].second<<endl;
        cout<<bottomRightPoints[i].first<<" "<<bottomRightPoints[i].second<<endl;
        cout<<"\n-----------\n";
        */
        bool fl=false;
        for(int red=topLeftPoints[i].first;red<=bottomRightPoints[i].first;red++) {
            for(int kol=topLeftPoints[i].second;kol<=bottomRightPoints[i].second;kol++) {
                if(table[red][kol]!=i) {
                    edges[table[red][kol]].push_back(i);
                    pokrivashti.insert(i);
                    pokrivashti.insert(table[red][kol]);
                }
            }
        }
    }
    cout<<uniq.size()<<endl;
    for(auto i: uniq) {
        cout<<i<<" "<<topLeftPoints[i].first<<" "<<topLeftPoints[i].second<<" "<<bottomRightPoints[i].first<<" "<<bottomRightPoints[i].second<<endl;
    }
   // cout<<pokrivashti.size();
   /*
    for(auto i: pokrivashti) {
        for(auto i: pokrivashti) {
            visited[i]=false;
        }
        redica.clear();
        namereni=0;
        dfs(i);
        for(auto k: pokrivashti) {
            if(!visited[k]) dfs(k);
        }
        //cout<<namereni;
        if(namereni==pokrivashti.size()) {
            for(int i=0;i<redica.size();i++) {
                cout<<redica[i]<<"\n";
            }
        }
    }
    */
    return 0;
}
