#include <bits/stdc++.h>

#define MAXN 1024
#define MAX_NUM 2048
#define endl '\n'

using namespace std;

int n, m;
int table[MAXN][MAXN];
bool visited[MAX_NUM];

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    cin >> n >> m;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            cin >> table[i][j];
            visited[table[i][j]] = true;
        }
    }

    int k = 0;
    vector<int> colors;

    for (int i = 1; i < MAX_NUM; i++) {
        if (visited[i]) {
            k++;
            colors.push_back(i);
        }
    }

    cout << k << endl;

    for (int x : colors) {
        int up;

        for (int i = 1; i <= n; i++) {
            bool found = false;

            for (int j = 1; j <= n; j++) {
                if (table[i][j] == x) {
                    up = i;
                    found = true;

                    break;
                }
            }

            if (found) break;
        }

        int le;

        for (int j = 1; j <= n; j++) {
            bool found = false;

            for (int i = 1; i <= n; i++) {
                if (table[i][j] == x) {
                    le = j;
                    found = true;

                    break;
                }
            }

            if (found) break;
        }

        int dw;

        for (int i = n; i >= 1; i--) {
            bool found = false;

            for (int j = 1; j <= n; j++) {
                if (table[i][j] == x) {
                    dw = i;
                    found = true;

                    break;
                }
            }

            if (found) break;
        }

        int ri;

        for (int j = n; j >= 1; j--) {
            bool found = false;

            for (int i = 1; i <= n; i++) {
                if (table[i][j] == x) {
                    ri = j;
                    found = true;

                    break;
                }
            }

            if (found) break;
        }

        cout << x << " " << up << " " << le << " " << dw << " " << ri << endl;
    }

    return 0;
}
