#include <bits/stdc++.h>

using namespace std;

string toBinary(long long number) {
    string bin;

    while (number != 0) {
        bin.push_back(char(number % 2 + '0'));
        number = number / 2;
    }

    reverse(bin.begin(), bin.end());

    return bin;
}

long long binomCoeficient(int a, int b) {
    if (a == b) return 1;
    if (b > a - b) b = a - b;

    long long result = a;

    long long x = a - 1, y = b;

    while (true) {
        if (x == a - b + 1 || y == 1) break;

        result = (result * x) / y;
    }

    return result;
}

long long binomCoeficient(long long a, long long b) {
    if (a == b) return 1;
    if (b > a - b) b = a - b;

    long long result = a;

    long long x = a - 1, y = b;

    while (true) {
        if (x < a - b + 1 || y == 1) break;

        result = (result * x) / y;

        x--;
        y--;
    }

    return result;
}

long long f(const string& x, int n, int s, bool l) {
    if (s < 0) return 0;
    if (n == 0 && s == 0) return 1;
    if (n == 0 && s != 0) return 0;

    long long ans = 0;

    for (int d = 0; d <= 1; d++) {
        if (!l) {
            if (d == 0) ans += f(x, n - 1, s - 1, false);
            if (d == 1) ans += f(x, n - 1, s, true);
        } else {
            if (d > (x[x.size() - n] - '0')) continue;
            if (d < (x[x.size() - n] - '0')) ans += f(x, n - 1, s - 1, false);
            if (d == (x[x.size() - n] - '0')) {
                if (d == 0) ans += f(x, n - 1, s - 1, true);
                if (d == 1) ans += f(x, n - 1, s, true);
            }
        }
    }

    return ans;
}

long long calculate(const string& maxNumber, int k) {
    if (maxNumber == "0") return 0;

    int n = maxNumber.size();
    long long ans = 0;

    for (int i = k + 1; i < n; i++) {
        ans += binomCoeficient(i - 1, k);
    }

    string newBound = maxNumber; newBound.erase(0, 1);

    return ans + f(newBound, newBound.size(), k, true);
}

int main() {
    long long l, r; cin >> l >> r;
    int k; cin >> k;

    string sr = toBinary(r);
    string sl = toBinary(l - 1);

    cout << calculate(sr, k) - calculate(sl, k) << endl;

    return 0;
}
