#include <bits/stdc++.h>
using namespace std;
int grid[1000][1000] = {0};
struct Coord{
    int r;
    int c;
    Coord(int ir, int ic){
        r = ir;
        c = ic;
    }
    Coord(){}
};
struct Rect{
    int mxr;
    int mxc;
    int mnr;
    int mnc;
    Rect(Coord c){
        mxr = c.r;
        mxc = c.c;
        mnr = c.r;
        mnc = c.c;
    }
    Rect(){}
    void add(Coord c){
        if(c.r > mxr){mxr = c.r;}
        if(c.r < mnr){mnr = c.r;}

        if(c.c > mxc){mxc = c.c;}
        if(c.c < mnc){mnc = c.c;}
    }
    Coord calcDR(){
        return {mxr, mxc};
    }
    Coord calcUL(){
        return {mnr, mnc};
    }
    bool isIn(Coord c){
        return (c.r<=mxr && c.c<=mxc && c.r>=mnr && c.c >= mnc);
    }
};
int vi_find(vector<int>& v, int n){
    for(int i = 0; i < v.size(); i++){
        if(v[i] == n){return i;}
    }
    return -1;
}
int main(){
    int N, M;
    cin >> N >> M;
    map<int, Rect> mp;
    int tmp;
    for(int i = 0; i < N; i++){
        for(int j = 0; j < M; j++){
            cin >> tmp;
            grid[i][j] = tmp;
            if(tmp==0){continue;}
            if(mp.count(tmp) == 0){
                mp[tmp] = Rect({i,j});
            }else{
                mp[tmp].add(Coord(i,j));
            }
        }
    }
    vector<int> layers;
    for(auto it = mp.begin(); it != mp.end(); it++){layers.push_back((*it).first);}
    vector<pair<int, int>> comps; //comparisons
    int grd; // number on grid for square
    int lyr; // current layer;
    for(int i = 0; i < N; i++){
        for(int j = 0; j < M; j++){
            if(grd == 0){continue;}
            grd = grid[i][j];
            for(auto it = mp.begin(); it != mp.end(); it++){
                lyr = (*it).first;
                if(lyr != grd && (*it).second.isIn({i,j})){
//                    cout << lyr << " before " << grd << '\n';
                    comps.push_back(make_pair(lyr, grd));
                }
            }
        }
    }
    sort(layers.begin(), layers.end(), [comps](int a, int b) {
        for(int i = 0; i < comps.size(); i++){
            if(comps[i].first == a && comps[i].second == b){
                return true;
            }
        }
        return false;
    });
    cout << layers.size() << '\n';
    for(int i = 0; i < layers.size(); i++){
        Rect r = mp[layers[i]];
        cout << layers[i] << ' ' << r.calcUL().r+1 << ' ' << r.calcUL().c+1 << ' ' << r.calcDR().r+1 << ' ' << r.calcDR().c+1 << '\n';
    }
    return 0;
}
