#include<iostream>
#include<vector>
#include<cstring>
using namespace std;
const int MAX_M=20;
const int MASK=(1<<18)+2;
int m;
int dp[MASK];
int pos[MAX_M][MAX_M];
vector<pair<int,int> >links;
vector<pair<int,int> >tri;
void Precompute()
{
    links.push_back({1,2});
    tri.push_back({3,0});

    links.push_back({1,3});
    tri.push_back({2,0});

    links.push_back({2,3});
    tri.push_back({1,5});

    links.push_back({2,4});
    tri.push_back({5,0});

    links.push_back({2,5});
    tri.push_back({3,4});

    links.push_back({3,5});
    tri.push_back({2,6});

    links.push_back({3,6});
    tri.push_back({5,0});

    links.push_back({4,5});
    tri.push_back({2,8});

    links.push_back({4,8});
    tri.push_back({5,7});

    links.push_back({4,7});
    tri.push_back({8,0});

    links.push_back({5,6});
    tri.push_back({3,9});

    links.push_back({5,9});
    tri.push_back({6,8});

    links.push_back({5,8});
    tri.push_back({4,9});

    links.push_back({6,10});
    tri.push_back({9,0});

    links.push_back({6,9});
    tri.push_back({5,10});

    links.push_back({7,8});
    tri.push_back({4,0});

    links.push_back({8,9});
    tri.push_back({5,0});

    links.push_back({9,10});
    tri.push_back({6,0});

    //CRINGE

    memset(pos,-1,sizeof(pos));
    for(int i=0;i<18;i++)
    {
        int l,r;
        l=links[i].first;
        r=links[i].second;
        pos[l][r]=pos[r][l]=i;
    }
}
int beg;
bool In(int i,int mask)
{
    return ((mask&(1<<i))!=0);
}
int Sum(int mask,int i)
{
    int l,r;

    l=links[i].first;
    r=links[i].second;

    int f,s;

    f=tri[pos[l][r]].first;
    s=tri[pos[l][r]].second;
    int pos1,pos2,pos3,pos4;
    pos1=pos[f][l];
    pos2=pos[f][r];
    pos3=pos[s][l];
    pos4=pos[s][r];

    int cnt=0;

    cnt+=(In(pos1,mask) && In(pos2,mask));
    cnt+=(In(pos3,mask) && In(pos4,mask));

    return cnt;
}
void Solve()
{
    int ans=0;
    int q;
    cin>>q;
    string ne;
    int l,r;
    while(q--)
    {
        cin>>ne>>l>>r;
        beg|=(1<<pos[l][r]);
    }
    memset(dp,-1,sizeof(dp));
    dp[beg]=0;
    for(int mask=beg;mask<(1<<18);mask++)
    {
        if(dp[mask]==-1)continue;
        for(int i=0;i<18;i++)
        {
            if(In(i,mask))continue;

            int cur=Sum(mask,i);

            if(!cur)continue;

            dp[mask|(1<<i)]=dp[mask]+cur;

            ans=max(ans,dp[mask]+cur);
        }
    }
    cout<<ans<<endl;
}
int main ()
{
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
    Precompute();
    Solve();
    return 0;
}
