#include<iostream>
#include<map>
#include<vector>
#include<algorithm>
#define endl '\n'
using namespace std;
const int MAXN = 1001;
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

int n, m, a[MAXN][MAXN];
struct rect
{
    int minx, maxx, miny, maxy;
    rect()
    {
    minx = 0;
    maxx = 0;
    miny = 0;
    maxy = 0;
    };
    rect(int _minx, int _maxx, int _miny, int _maxy)
    {
        minx = _minx;
        maxx = _maxx;
        miny = _miny;
        maxy = _maxy;
    }
};
bool seen[2002];
map < int , rect > mp;
vector < int > colors;
void read()
{
    cin >> n >> m;
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            cin >> a[i][j];
            if(a[i][j])
            {
                if(mp[a[i][j]].minx == 0 || mp[a[i][j]].minx > i)mp[a[i][j]].minx = i;
                if(mp[a[i][j]].maxx == 0 || mp[a[i][j]].maxx < i)mp[a[i][j]].maxx = i;
                if(mp[a[i][j]].miny == 0 || mp[a[i][j]].miny > j)mp[a[i][j]].miny = j;
                if(mp[a[i][j]].maxy == 0 || mp[a[i][j]].maxy < j)mp[a[i][j]].maxy = j;
                if(!seen[a[i][j]]){seen[a[i][j]] = 1; colors.push_back(a[i][j]);}
            }
        }
    }
}

vector < int > v[2002];
int edge[2002][2002];
void fill_v(rect k, int c)
{
    for (int i = k.minx; i <= k.maxx; ++ i)
    {
        for (int j = k.miny; j <= k.maxy; ++ j)
        {
            if(a[i][j] && a[i][j] != c && edge[c][a[i][j]] == 0)
            {
                v[c].push_back(a[i][j]);
                edge[c][a[i][j]] = 1;
            }
        }
    }
}
void print_v()
{
    for (int i = 0; i < colors.size(); ++ i)
    {
        int c = colors[i];
        cout << c << ": "<< endl;
        for (int j = 0; j < v[c].size(); ++ j)
        {
            cout << v[c][j] << endl;
        }
    }
}

vector < int > path;

int used[2002];
void dfs(int beg)
{
    used[beg] = 1;
    int nb;
    for (int i = 0; i < v[beg].size(); ++ i)
    {
        nb = v[beg][i];
        if(!used[nb])
        {
            dfs(nb);

        }
    }
    path.push_back(beg);
}


void solve()
{

    int c;
    for(int i = 0; i < colors.size(); ++ i)
    {
        c = colors[i];
        fill_v(mp[c], c);
    }
    //print_v();
    for(int i = 0; i < colors.size(); ++ i)
    {
        c = colors[i];
        if(!used[c])dfs(c);
    }

    //reverse(path.begin(), path.end());
cout << colors.size() << endl;
    for (int i = path.size()-1; i >= 0; -- i)
    {
        c = path[i];
        cout << c << " " << mp[c].minx << " " << mp[c].miny << " " << mp[c].maxx << " " << mp[c].maxy << endl;
    }

}


int main()
{
speed();
read();
///print_mp();
solve();

    return 0;
}
/**
4 3
1 1 2
1 1 2
5 5 3
5 5 5
------
4 5
1 1 1 2 2
1 3 3 2 2
0 3 3 4 4
2 0 4 4 4
*/
