#include <iostream>
#include <vector>
#include <string>
using namespace std;

void printer(string message,vector<long> data) {
    cout << message << endl;
    for(auto it = data.begin();it!=data.end();++it) cout<<*it;
    cout<<endl;
}

vector<long> vectorize(long arr[]) {
    vector<long> data;
    for(long i=0;i<64;i++) data.push_back(arr[i]);
    return data;
}

vector<long> calcBit(long bits[],long n) {
    if(n==64) return vectorize(bits);
        if(bits[n] == 0 || bits[n] == 2) {
            bits[n] = 1;
            //printer("calcBit first case result", vectorize(bits));
            return vectorize(bits);
        } else {
            bits[n] = 0;
            //printer("calcBit second case result", vectorize(bits));
            return calcBit(bits,n+1);
        }
}

vector<long> bit(long num) {
    long bits[64];
    for(long i=0;i<64;i++) bits[i] = 2;
    //printer("bit beginning", vectorize(bits));
    for(long i=0;i<num;i++) {
        vector<long> bitss = calcBit(bits,0);
        long j=0;
        for(auto it = bitss.begin();it!=bitss.end();++it) {
            bits[j] = *it;
            j++;
        }
    }
    //printer("bit result", vectorize(bits));
    return vectorize(bits);
}

int main() {
    cout.sync_with_stdio(false);
    cin.tie(0);

    long l,r,k;
    cin >> l >> r >> k;
    long nums = 0;
    for(long i=l;i<=r;i++) {
        vector<long> bits = bit(i);
        long zeroes=0;
        for(auto it = bits.begin();it!=bits.end();++it) if(*it==0) zeroes++;
        if(zeroes == k) {
            nums++;
            zeroes=0;
        }
    }
    cout<<nums;
}
