#include<iostream>
#include<vector>
using namespace std;

vector<int> nei[15];
bool used[15][15], isNei[15][15];

void load() {
    nei[1].push_back(2);
    nei[1].push_back(3);
    nei[2].push_back(3);
    nei[2].push_back(4);
    nei[2].push_back(5);
    nei[3].push_back(5);
    nei[3].push_back(6);
    nei[4].push_back(5);
    nei[4].push_back(7);
    nei[4].push_back(8);
    nei[5].push_back(6);
    nei[5].push_back(8);
    nei[5].push_back(9);
    nei[6].push_back(9);
    nei[6].push_back(10);
    nei[7].push_back(8);
    nei[8].push_back(9);
    nei[9].push_back(10);
    isNei[1][2] = true;
    isNei[1][3] = true;
    isNei[2][3] = true;
    isNei[2][4] = true;
    isNei[2][5] = true;
    isNei[3][5] = true;
    isNei[3][6] = true;
    isNei[4][5] = true;
    isNei[4][7] = true;
    isNei[4][8] = true;
    isNei[5][6] = true;
    isNei[5][8] = true;
    isNei[5][9] = true;
    isNei[6][9] = true;
    isNei[6][10] = true;
    isNei[7][8] = true;
    isNei[8][9] = true;
    isNei[9][10] = true;
}

bool isAns(int a, int b) {
    for(int i = 0; i <= 10; i++) {
        if(isNei[min(a,i)][max(a,i)] && used[min(a,i)][max(a,i)] && used[min(i,b)][max(i,b)] && isNei[min(b,i)][max(b,i)]) {
            used[a][b] = true;
            return true;
        }
    }
    return false;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin>>n;
    for(int i = 0; i < n; i++) {
        char c;
        cin>>c>>c;
        int u, v;
        cin>>u>>v;
        used[u][v] = true;
    }

    load();

    int ans = 0;
    for(int i = 0; i < 10; i++) {
        for(auto j : nei[i]) {
            if(!used[i][j] && isAns(i, j)) {
                ans++;
                i = -1;
            }
        }
    }
    cout<<ans<<endl;

    return 0;
}
