#include<iostream>
#include<vector>
using namespace std;

int paper[1000][1000];
int limit[2001][4];
bool in[2001];
vector<int> rects;
vector<int> rect_order;
vector<int> covers[2001];
int num_covers[2001];

void func(int t){
    rect_order.push_back(t);
    num_covers[t]=-1;
    for(int j=0;j<covers[t].size();j++){
        num_covers[covers[t][j]]--;
        if(num_covers[covers[t][j]]==0)func(covers[t][j]);
    }
}

int main(){
    int n,m,k;
    /// Entry
    cin>>n>>m;
    for(int i=0;i<n;i++){
        for(int j=0;j<m;j++){
            cin>>k;
            paper[i][j]=k;
            if(k==0)continue;
            if(!in[k]){
                rects.push_back(k);
                in[k]=true;
                limit[k][0]=i;
                limit[k][1]=j;
                limit[k][2]=i;
                limit[k][3]=j;
                continue;
            }
            if(i<limit[k][0])limit[k][0]=i;
            if(j<limit[k][1])limit[k][1]=j;
            if(i>limit[k][2])limit[k][2]=i;
            if(j>limit[k][3])limit[k][3]=j;
        }
    }
    for(int i=0;i<rects.size();i++){
        int min_y=limit[rects[i]][0];
        int min_x=limit[rects[i]][1];
        int max_y=limit[rects[i]][2];
        int max_x=limit[rects[i]][3];
        int k=rects[i];
        for(int y=min_y;y<=max_y;y++){
            for(int x=min_x;x<=max_x;x++){
                if(paper[y][x]!=k){
                    if(covers[paper[y][x]].size()==0||covers[paper[y][x]].back()!=k){
                        num_covers[k]++;
                        covers[paper[y][x]].push_back(k);
                    }
                }
            }
        }
    }
    for(int i=0;i<rects.size();i++){
        if(num_covers[rects[i]]==0)func(rects[i]);
    }
    cout<<rect_order.size()<<endl;
    for(int i=rect_order.size()-1;i>=0;i--){
        int t=rect_order[i];
        cout<<t<<" "<<limit[t][0]+1<<" "<<limit[t][1]+1<<" "<<limit[t][2]+1<<" "<<limit[t][3]+1<<endl;
    }
}
