#include<bits/stdc++.h>
using namespace std;
int table[1002][1002];
int rect[2000][4];
vector<int> rectangles;
vector<int> order;
bool Full(int,int,int,int,int);
bool Refillable(int,int,int,int,int);
void Replace(int,int,int,int,int);
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n,m;
    cin>>n>>m;
    for(int i=1;i<=n;i++){
        for(int j=1;j<=m;j++){
            cin>>table[i][j];
            if(table[i][j]==0) continue;
            if(rect[table[i][j]][0]==0){
                rect[table[i][j]][0]=i;
                rectangles.push_back(table[i][j]);
            }
            if(rect[table[i][j]][1]==0) rect[table[i][j]][1]=j;
            else rect[table[i][j]][1]=min(rect[table[i][j]][1],j);
            rect[table[i][j]][2]=i;
            rect[table[i][j]][3]=max(rect[table[i][j]][3],j);
        }
    }
    cout<<rectangles.size()<<"\n";
    while(rectangles.size()>0){
        for(int i=0;i<rectangles.size();i++){
            if(Full(rect[rectangles[i]][0],rect[rectangles[i]][1],rect[rectangles[i]][2],rect[rectangles[i]][3],rectangles[i])){
                Replace(rect[rectangles[i]][0],rect[rectangles[i]][1],rect[rectangles[i]][2],rect[rectangles[i]][3],-1);
                order.push_back(rectangles[i]);
                rectangles.erase(rectangles.begin()+i);
                i--;
            }
        }
        for(int i=0;i<rectangles.size();i++){
            if(Refillable(rect[rectangles[i]][0],rect[rectangles[i]][1],rect[rectangles[i]][2],rect[rectangles[i]][3],rectangles[i])){
                Replace(rect[rectangles[i]][0],rect[rectangles[i]][1],rect[rectangles[i]][2],rect[rectangles[i]][3],rectangles[i]);
            }
        }
    }
    reverse(order.begin(),order.end());
    for(int i=0;i<order.size();i++){
        cout<<order[i]<<" "<<rect[order[i]][0]<<" "<<rect[order[i]][1]<<" "<<rect[order[i]][2]<<" "<<rect[order[i]][3]<<"\n";
    }
    return 0;
}
bool Full(int u,int l,int d,int r,int n){
    for(int i=u;i<=d;i++){
        for(int j=l;j<=r;j++){
            if(table[i][j]!=n) return false;
        }
    }
}
bool Refillable(int u,int l,int d,int r,int n){
    for(int i=u;i<=d;i++){
        for(int j=l;j<=r;j++){
            if(table[i][j]!=n && table[i][j]!=-1) return false;
        }
    }
}
void Replace(int u,int l,int d,int r,int n){
    for(int i=u;i<=d;i++){
        for(int j=l;j<=r;j++){
            table[i][j]=n;
        }
    }
}
