#include <iostream>
#include <vector>
#include <utility>

using namespace std;

int Convert[11][11];

vector <pair <int, int>> Tr[18];

void Init()
{
    Convert[1][2] = 0;
    Convert[1][3] = 1;
    Convert[2][3] = 2;
    Convert[2][4] = 3;
    Convert[2][5] = 4;
    Convert[3][5] = 5;
    Convert[3][6] = 6;
    Convert[4][5] = 7;
    Convert[5][6] = 8;
    Convert[4][7] = 9;
    Convert[4][8] = 10;
    Convert[5][8] = 11;
    Convert[5][9] = 12;
    Convert[6][9] = 13;
    Convert[6][10] = 14;
    Convert[7][8] = 15;
    Convert[8][9] = 16;
    Convert[9][10] = 17;

    Tr[0].push_back({1, 2});
    Tr[1].push_back({0, 2});
    Tr[2].push_back({0, 1});      Tr[2].push_back({4, 5});
    Tr[3].push_back({4, 7});
    Tr[4].push_back({3, 7});      Tr[4].push_back({2, 5});
    Tr[5].push_back({2, 4});      Tr[5].push_back({6, 8});
    Tr[6].push_back({5, 8});
    Tr[7].push_back({3, 4});      Tr[7].push_back({10, 11});
    Tr[8].push_back({5, 6});      Tr[8].push_back({12, 13});
    Tr[9].push_back({10, 15});
    Tr[10].push_back({9, 15});    Tr[10].push_back({7, 11});
    Tr[11].push_back({7, 10});    Tr[11].push_back({12, 16});
    Tr[12].push_back({11, 16});   Tr[12].push_back({8, 13});
    Tr[13].push_back({8, 12});    Tr[13].push_back({14, 17});
    Tr[14].push_back({13, 17});
    Tr[15].push_back({9, 10});
    Tr[16].push_back({11, 12});
    Tr[17].push_back({13, 14});
}

struct State
{
    bool Filled[18] = { false };

    void Fill(int A)
    {
        Filled[A] = true;
    }

    void Unfill(int A)
    {
        Filled[A] = true;
    }

    void EnterPosition()
    {
        int A;

        cin >> A;

        for (int i = 0; i < A ; i++)
        {
            string T;
            cin >> T;

            int P;
            int Q;

            cin >> P;
            cin >> Q;

            if (P > Q)
            {
                swap (P, Q);
            }

            Filled[Convert[P][Q]] = true;
        }
    }

    void PrintPosition()
    {
        for (int i = 0; i < 18; i++)
        {
            cout << i << " - " << Filled[i] << endl;
        }

        cout << endl;
    }
};

int MaxMoves(State &Position)
{
    ///Position.PrintPosition();
    int M = 0;
    for (int i = 0; i < 18; i++)
    {
        if (!Position.Filled[i])
        {
            bool Valid = false;
            for (int j = 0; j < Tr[i].size(); j++)
            {
                if (Position.Filled[Tr[i][j].first] && Position.Filled[Tr[i][j].second])
                {
                    Valid = true;
                }
            }

            if (Valid)
            {
                Position.Fill(i);
                M = max(M, MaxMoves(Position));
                Position.Unfill(i);
            }
        }
    }

    return M + 1;
}

int main()
{
    Init();
    State A;

    A.EnterPosition();

    cout << MaxMoves(A) - 1;
}
