#include<iostream>
#include<set>
#include<cstring>
#include<algorithm>
#include<vector>
using namespace std;
const int MAX_NUM=2e3+3;
const int MAX_N=1e3+3;
set<int>cc;
vector<int>c;
vector<int>g[MAX_NUM];
int rect[MAX_NUM][4];
int n,m;
int a[MAX_N][MAX_N];
vector<int>rects;
int out[MAX_NUM];
void Read()
{
    cin>>n>>m;
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            cin>>a[i][j];
            int x=a[i][j];
            if(x)cc.insert(x);
            rect[x][0]=rect[x][2]=1e6;
        }
    }
    for(int cur:cc)
    {
        c.push_back(cur);
    }
}
bool In(int x,int i,int j)
{
    if(!a[i][j])return 0;
    if(rect[x][0]<=j && j<=rect[x][1] && rect[x][2]<=i && i<=rect[x][3])return 1;
    return 0;
}
void Check(int i,int j)
{
    int x=a[i][j];
    if(In(x,i+1,j))g[x].push_back(a[i+1][j]);
    if(In(x,i-1,j))g[x].push_back(a[i-1][j]);
    if(In(x,i,j+1))g[x].push_back(a[i][j+1]);
    if(In(x,i,j-1))g[x].push_back(a[i][j-1]);
}
void Precompute()
{
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            if(!a[i][j])continue;
            int x=a[i][j];
            rect[x][0]=min(rect[x][0],j);
            rect[x][1]=max(rect[x][1],j);
            rect[x][2]=min(rect[x][2],i);
            rect[x][3]=max(rect[x][3],i);
        }
    }

    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            int x=a[i][j];
            if(!x)continue;
            Check(i,j);
        }
    }
    for(int y:c)
    {
        for(int x:c)
        {
            if(x==y)continue;
            if(rect[x][0]<=rect[y][0] && rect[y][1]<=rect[x][1] && rect[x][2]<=rect[y][2] && rect[y][3]<=rect[x][3])out[y]++;
        }
    }

}
vector<int>top;
bool used[MAX_NUM];
void DFS(int u)
{
    used[u]=1;
    for(int v:g[u])
    {
        if(!used[v])DFS(v);
    }
    top.push_back(u);
}
void Solve()
{
    for(int x:c)
    {
        if(!used[x])
        {
            DFS(x);
        }
    }
    reverse(top.begin(),top.end());
    cout<<cc.size()<<"\n";
    for(int x:top)
    {
        cout<<x<<" "<<rect[x][2]<<" "<<rect[x][0]<<" "<<rect[x][3]<<" "<<rect[x][1]<<"\n";
    }
}
int main ()
{
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
    Read();
    Precompute();
    Solve();
    return 0;
}
