#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

uint64_t combinations[65][65] = {0};
void calcCombinations()
{
    combinations[0][0] = 1;
    for (int i = 1; i <= 60; i++)
    {
        combinations[i][0] = combinations[i][i] = 1;
        for (int j = 1; j < i; j++)
        {
            combinations[i][j] = combinations[i-1][j-1] + combinations[i-1][j];
        }
    }
}

int64_t POW(int64_t a, int64_t p)
{
    int64_t ans = 1;
    for (int64_t i = 0; i < p; i++)
        ans *= a;
    return ans;
}
int br0(int64_t n)
{
    int br = 0;
    for (int k = 0; (1LL<<k) <= n; k++)
    {
        br +=  (((n>>k)&1)^1);
    }

    return br;
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int64_t l, r, k, answer = 0;

    cin >> l >> r >> k;
    calcCombinations();


    int64_t a = log2(l);
    if (POW(2, a) != l)
    {
        a = POW(2, a);
    }
    else a = POW(2, a);

    int64_t b = log2(r);
    if (POW(2, b) != r)
    {
        b = POW(2, b+1)-1;
    }
    else
    {
        if (br0(r) == k)
            answer++;

        b = POW(2, b)-1;
    }

    int64_t start = log2(a), finish = log2(b);
    for (int64_t i = start; i <= finish; i++)
    {
        answer += combinations[i][k];
    }

    for (int64_t i = a; i < l; i++)
    {
        if (br0(i) == k)
            answer--;
    }

    for (int64_t i = b; i > r; i--)
    {
        if (br0(i) == k)
            answer--;
    }

    cout << answer << endl;

    return 0;
}
