#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

bool connection[12][12];

vector <int> edges[15];
array <tuple<int, int, int>, 9> triangles;

void fillArrays()
{
    edges[1].push_back(2);
    edges[1].push_back(3);

    edges[2].push_back(1);
    edges[2].push_back(3);
    edges[2].push_back(4);
    edges[2].push_back(5);

    edges[3].push_back(1);
    edges[3].push_back(2);
    edges[3].push_back(5);
    edges[3].push_back(6);

    edges[4].push_back(2);
    edges[4].push_back(5);
    edges[4].push_back(8);
    edges[4].push_back(7);

    edges[5].push_back(2);
    edges[5].push_back(3);
    edges[5].push_back(4);
    edges[5].push_back(6);
    edges[5].push_back(8);
    edges[5].push_back(9);

    edges[6].push_back(3);
    edges[6].push_back(5);
    edges[6].push_back(9);
    edges[6].push_back(10);

    edges[7].push_back(4);
    edges[7].push_back(8);

    edges[8].push_back(4);
    edges[8].push_back(5);
    edges[8].push_back(7);
    edges[8].push_back(9);

    edges[9].push_back(5);
    edges[9].push_back(6);
    edges[9].push_back(8);
    edges[9].push_back(10);

    edges[10].push_back(6);
    edges[10].push_back(9);


    triangles[0] = {1, 2, 3};
    triangles[1] = {2, 4, 5};
    triangles[2] = {2, 3, 5};
    triangles[3] = {3, 5, 6};
    triangles[4] = {4, 7, 8};
    triangles[5] = {4, 5, 8};
    triangles[6] = {5, 8, 9};
    triangles[7] = {5, 6, 9};
    triangles[8] = {6, 9, 10};
}

int filledTriangles()
{
    int br = 0;
    for (auto& [a, b, c]:triangles)
    {
        if (connection[a][b] == true)
            if (connection[b][c] == true)
                if (connection[a][c] == true)
                    br++;
    }
    return br;
}

int MAX = 0;

deque <pair <int, int>> temp;
vector <pair <int, int>> andrew;
void makeTurnPeter(int br)
{

    MAX = max(MAX, br);

    for (int i = 1; i <= 10; i++)
    {
        for (int destination:edges[i])
        {
            if (connection[i][destination] == false)
            {
                int br1 = filledTriangles();
                connection[i][destination] = connection[destination][i] = true;
                int br2 = filledTriangles();

                if (br1 < br2)
                    makeTurnPeter(br+1);

                connection[i][destination] = connection[destination][i] = false;
            }

        }
    }

}

int MIN = 1000;
void makeTurnAndrew()
{
    for (int i = 1; i <= 10; i++)
    {
        for (int destination:edges[i])
        {
            if (connection[i][destination] == false)
            {
                int br1 = filledTriangles();
                connection[i][destination] = connection[destination][i] = true;
                int br2 = filledTriangles();

                if (br1 < br2)
                    makeTurnAndrew();

                MAX = 0;
                makeTurnPeter(0);
                MIN = min(MIN, MAX);

                connection[i][destination] = connection[destination][i] = false;
            }

        }
    }

}

void fillAndrew(vector <pair <int, int>>& hodove)
{
    for (auto& [i, j]:hodove)
        connection[i][j] = connection[j][i] = true;
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int m, l, r;
    char input[3];

    fillArrays();

    bool turn = 0;
    cin >> m;
    for (int i = 0; i < m; i++)
    {
        cin >> input;
        cin >> l >> r;

        if (input[0] == 'P')
            turn = 0;
        else
            turn = 1;

        int br1 = filledTriangles();
        connection[l][r] = true;
        connection[r][l] = true;
        int br2 = filledTriangles();

        if (br2 == br1)
            turn = turn^1;
    }

    if (turn == 0)
    {
        makeTurnPeter(0);
        cout << MAX << endl;
    }

    else
    {
        makeTurnAndrew();

        cout << MIN << endl;
    }

    return 0;
}
/*
2
A: 1 2
P: 1 3


*/

/*
6
P: 1 2
A: 4 7
P: 5 6
A: 8 9
P: 4 5
A: 5 8
*/
