#include<iostream>
#include<map>
#include<vector>
#define endl '\n'
using namespace std;
const int MAXN = 1001;
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

int n, m, a[MAXN][MAXN];
struct rect
{
    int minx, maxx, miny, maxy;
    rect()
    {
    minx = 0;
    maxx = 0;
    miny = 0;
    maxy = 0;
    };
    rect(int _minx, int _maxx, int _miny, int _maxy)
    {
        minx = _minx;
        maxx = _maxx;
        miny = _miny;
        maxy = _maxy;
    }
};
bool seen[2002];
map < int , rect > mp;
vector < int > colors;
void read()
{
    cin >> n >> m;
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            cin >> a[i][j];
            if(a[i][j])
            {
                if(mp[a[i][j]].minx == 0 || mp[a[i][j]].minx > i)mp[a[i][j]].minx = i;
                if(mp[a[i][j]].maxx == 0 || mp[a[i][j]].maxx < i)mp[a[i][j]].maxx = i;
                if(mp[a[i][j]].miny == 0 || mp[a[i][j]].miny > j)mp[a[i][j]].miny = j;
                if(mp[a[i][j]].maxy == 0 || mp[a[i][j]].maxy < j)mp[a[i][j]].maxy = j;
                if(!seen[a[i][j]]){seen[a[i][j]] = 1; colors.push_back(a[i][j]);}
            }
        }
    }
}

void print_mp()
{
    for (int i = 0; i < colors.size(); ++ i)
    {
        cout << colors[i] << " -> " << mp[colors[i]].minx << ", " << mp[colors[i]].maxx << ", " << mp[colors[i]].miny << ", " << mp[colors[i]].maxy << endl;
    }
}

void solve()
{
    int c;
    cout << colors.size() << endl;
    for (int i = 0; i < colors.size(); ++ i)
    {
        c = colors[i];
        cout << c << " " << mp[c].minx << " " << mp[c].miny << " " << mp[c].maxx << " " << mp[c].maxy << endl;
    }
}
int main()
{
speed();
read();
///print_mp();
solve();
    return 0;
}
