#include<bits/stdc++.h>
using namespace std;
struct point
{
    int x,y;
    point() {}
    point(int _x, int _y)
    {
        x=_x;
        y=_y;
    }
};
int n,m;
int a[1024][1024];
point beg[2048];
point fin[2048];
void read()
{
    cin>>n>>m;
    for(int i=1; i<=n; i++)
    {
        for(int j=1; j<=m; j++)
        {
            cin>>a[i][j];
            int c=a[i][j];
            if(beg[c].x==0&&beg[c].y==0)
            {
                beg[c].x=i;
                beg[c].y=j;
            }
            else if(beg[c].x>i)
            {
                beg[c].x=i;
            }
            else if(beg[c].y>j)
            {
                beg[c].y=j;
            }
            if(fin[c].x==0&&fin[c].y==0)
            {
                fin[c].x=i;
                fin[c].y=j;
            }
            else if(fin[c].x<i)
            {
                fin[c].x=i;
            }
            else if(fin[c].y<j)
            {
                fin[c].y=j;
            }
        }
    }
}
vector<int> v;
bool used[2048];
void DFS(int c)
{
    //cout<<c<<endl;
    used[c]=1;
    for(int i=beg[c].x; i<=fin[c].x; i++)
    {
        for(int j=beg[c].y; j<=beg[c].y; j++)
        {
            if(a[i][j]!=c&&used[a[i][j]]==0)
                DFS(a[i][j]);
        }
    }
    v.push_back(c);
}
void solve()
{
    for(int i=1; i<2048; i++)
    {
        if(beg[i].x!=0&&!used[i])
        {
            DFS(i);
        }
    }
}
void print()
{
    for(int i=v.size()-1; i>=0; i--)
    {
        int c=v[i];
        cout<<c<<" "<<beg[c].x<<" "<<beg[c].y<<" "<<fin[c].x<<" "<<fin[c].y<<endl;
    }
}
void print_color()
{
    for(int c=1; c<=5; c++)
    {
        cout<<c<<" "<<beg[c].x<<" "<<beg[c].y<<" "<<fin[c].x<<" "<<fin[c].y<<endl;
    }
}
int main()
{
    read();
    solve();
    print();
    //print_color();
    return 0;
}
