#include <bits/stdc++.h>
#pragma GCC optimize ("-O3")

using namespace std;

const int maxn = 65;
unsigned long long l, r, k;
string pasc[maxn][maxn];

string fill0(string a, int len){
    for(int i = 0;i < len;i++){
        a = '0' + a;
    }
    return a;
}

string sub(string a, string b){
    int len1 = a.size(), len2 = b.size();
    if(len1 > len2) b = fill0(b, len1 - len2);
    else a = fill0(a, len2 - len1);
    int len = a.size(), pren = 0;
    string res = "";
    for(int i = len - 1;i >= 0;i--){
        int c = (a[i] - '0') + (b[i] - '0') + pren;
        pren = c / 10;
        c %= 10;
        res = (char)(c + '0') + res;
    }
    if(pren) res = (char)(pren + '0') + res;
    return res;
}
void fill_pasc(){
    for(int i = 1;i < maxn;i++){
        for(int j = 1;j < maxn;j++){
            pasc[i][j] = "0";
        }
    }
    for(int i = 1;i < maxn;i++){
        pasc[i][0] = "1";
    }
    for(int i = 1;i < maxn;i++){
        pasc[0][i] = "1";
    }
    for(int i = 1;i < maxn;i++){
        for(int j = 1;j <= i;j++){
            pasc[i][j] = sub(pasc[i - 1][j], pasc[i - 1][j - 1]);
        }
    }
}

string check(unsigned long long p){
    int cnt = 0;
    do{
        if(p % 2 == 0) cnt++;
        p /= 2;
    }while(p);
    return (cnt == k? "1":"0");
}
void solve(){
    string ans = "0";
    unsigned long long firstl = -1, lastr = -1;
    for(int i = 1;(1 << (i + 1)) <= r;i++){
        if(l <= (1 << i) && (1 << (i + 1)) <= r){
            ans = sub(ans, pasc[i][k]);
            if(firstl == -1) firstl = (1 << i);
            lastr = (1 << (i + 1));
        }
    }
    if(firstl == -1){
        for(unsigned long long i = l;i <= r;i++){
            ans = sub(ans, check(i));
        }

    }
    else{
        for(unsigned long long i = l;i < firstl;i++){
            ans = sub(ans, check(i));
        }
        for(unsigned long long i = lastr + 1;i <= r;i++){
            ans = sub(ans, check(i));
        }
    }
    cout << ans << endl;

}
int main()
{
    ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	cin >> l >> r >> k;
	fill_pasc();
	solve();

	return 0;
}
