#include <bits/stdc++.h>

using namespace std;

struct rect
{
    int num;
    int up;
    int down;
    int left;
    int right;
    rect()
    {
        num=-1;
        up=-1;
        down=-1;
        left=-1;
        right=-1;
    }
};

const int maxn=2048;
const int maxr=2048;
int n,m;
int a[maxn][maxn];
int matri[maxn][maxn];
int used[maxr];
rect r[maxr];
vector<rect>v;
vector<int>spisuk[maxr];
vector<int>ans;


void read()
{
    cin >> n >> m;
    int ch;
    rect nb;
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            cin >> a[i][j];
            if(a[i][j]!=0)
            {
                ch=a[i][j];
                nb=r[ch];
                nb.num=ch;
                if(nb.up==-1||i<nb.up) nb.up=i;
                if(nb.down==-1||i>nb.down) nb.down=i;
                if(nb.left==-1||j<nb.left) nb.left=j;
                if(nb.right==-1||j>nb.right) nb.right=j;
                r[ch]=nb;
            }
        }
    }
}

void compr()
{
    for(int i=1;i<=2000;i++)
    {
        if(r[i].num==i) v.push_back(r[i]);
    }
}

void DFS(int beg)
{
    used[beg]=1;
    int sz=spisuk[beg].size();
    int nb;
    for(int i=0;i<sz;i++)
    {
        nb=spisuk[beg][i];
        if(!used[nb]) DFS(nb);
    }
    if(r[beg].num==beg) ans.push_back(beg);
}
void top_sort()
{
    for(int i=1;i<=2000;i++)
    {
        if(!used[i]) DFS(i);
    }
    reverse(ans.begin(),ans.end());

}
void solve()
{
    compr();
    int sz=v.size();
    rect nb;
    int ch;
    for(int q=0;q<sz;q++)
    {
        nb=v[q];
        for(int i=nb.up;i<=nb.down;i++)
        {
            for(int j=nb.left;j<=nb.right;j++)
            {
                ch=a[i][j];
                if(ch!=nb.num&&ch!=0&&!matri[nb.num][ch]&&!matri[ch][nb.num])
                {
                    matri[nb.num][ch]=1;
                    matri[ch][nb.num]=1;
                    spisuk[nb.num].push_back(ch);
                }
            }
        }
    }
    top_sort();
    int siz=ans.size();
    cout << siz << endl;
    for(int i=0;i<siz;i++)
    {
        nb=r[ans[i]];
        cout << nb.num << " " << nb.up << " " << nb.left << " " << nb.down << " " << nb.right << endl;
    }
}
int main()
{
    read();
    solve();
    return 0;
}
